Index: docs/dev/metacat/source/intro.rst
===================================================================
--- docs/dev/metacat/source/intro.rst	(revision 6832)
+++ docs/dev/metacat/source/intro.rst	(revision 6833)
@@ -1,7 +1,7 @@
 Introduction
 ============
 
-Metacat is a repository for data and metadata (data about data), which helps
+Metacat is a repository for data and metadata (descriptions of data) that helps
 scientists find, understand and effectively use the data sets they manage or
 that have been created by others. Thousands of data sets are currently
 documented in a standardized way and stored in Metacat systems, providing the
@@ -22,18 +22,18 @@
 immediately download the data via the Web).
 
 Metacat's user-friendly Registry application allows data providers to enter
-data-set documentation into Metacat using a Web form. When the form is
+data set documentation into Metacat using a Web form. When the form is
 submitted, Metacat compiles the provided documentation into the required format
-and saves it. Information providers need never work directly with the XML
-format in which the data are stored or with the database records themselves. In
+and saves it. Information providers need never work directly with the XML_
+format in which the metadata are stored or with the database records themselves. In
 addition, the Metacat application can easily be extended to provide a
 customized data-entry interface that suits the particular requirements of each
 project. Metacat users can also choose to enter metadata using the Morpho
-application, which provides data-entry wizards that guide information providers
+application, which provides data entry wizards that guide information providers
 through the process of documenting each data set.
 
-The metadata stored in Metacat includes all of the information you and others
-need to understand what the described data are and how to use them: a
+The metadata stored in Metacat includes all of the information needed
+to understand what the described data are and how to use them: a
 descriptive data set title; an abstract; the temporal, spatial, and taxonomic
 coverage of the data; the data collection methods; distribution information;
 and contact information. Each information provider decides who has access to
@@ -42,18 +42,34 @@
 can also edit the metadata or delete it from the repository, again using
 Metacat's straightforward Web interface.
 
-Metacat is a Java servlet application that runs on Window or Linux platforms in
-conjunction with a database, such as PostgreSQL (or Oracle 8i), and a Web
-server. The Metacat application stores data in an XML format using Ecological
-Metadata Language (EML) or another ecological metadata standard. For more
+Metacat is a `Java servlet`_ application that runs on Linux, Mac OS, and
+Windows platforms in conjunction with a database, such as 
+PostgreSQL_ (or Oracle_), and a Web
+server. The Metacat application stores data in an XML_ format using `Ecological
+Metadata Language`_ (EML) or other metadata standards such as `ISO 19139`_ or the
+`FGDC Biological Data Profile`_. For more
 information about Metacat or for examples of projects currently using Metacat,
 please see http://knb.ecoinformatics.org.
 
+.. _XML: http://en.wikipedia.org/wiki/XML
+
+.. _Java servlet: http://en.wikipedia.org/wiki/Java_Servlet
+
+.. _PostgreSQL: http://www.postgresql.org/
+
+.. _Oracle: http://www.oracle.com/
+
+.. _Ecological Metadata Language: http://knb.ecoinformatics.org/software/eml
+
+.. _ISO 19139: http://marinemetadata.org/references/iso19139 
+
+.. _FGDC Biological Data Profile: http://www.fgdc.gov/standards/projects/FGDC-standards-projects/metadata/biometadata 
+
 What's in this Guide
 --------------------
-The Administrator guide includes information for installing, configuring,
-managing and extending Metacat for both Linux and Windows systems. Chapter Two
-contains instructions for downloading and installing Metacat and the
+This Administrator's guide includes information for installing, configuring,
+managing and extending Metacat for both Linux, Mac OS, and Windows systems. 
+Chapter Two contains instructions for downloading and installing Metacat and the
 applications required to run the software on Linux and Microsoft platforms.
 Chapter Three covers how to configure Metacat, both for new and upgraded
 installations. Chapter Four details the ways in which you can customize the
@@ -60,7 +76,7 @@
 Metacat interface so users can access and submit information easily: using
 Metacat's generic web-interface (the Registry), creating your own HTML forms,
 and creating your own desktop client (like Morpho). Chapter Five discusses how
-to work with Metacat's Geoserver. Chapter Six describes how to set up the
+to work with Metacat's embedded Geoserver. Chapter Six describes how to set up the
 Metacat's replication service, which permits Metacat servers to share data with
 each other, effectively backing up metadata and data files. Chapter Seven looks
 at the Metacat Harvester, a program that automates the retrieval of EML
@@ -72,18 +88,25 @@
 
 Metacat Features
 ----------------
-Metacat is a repository for metadata (data about data), which help scientists
-find, understand and effectively use the data sets they manage or that have
-been created by others. Specifically,
+Metacat is a repository for data and metadata (documentation about data), that 
+helps scientists find, understand and effectively use the data sets they manage or 
+that have been created by others. Specifically,
 
-* Metacat is a Java servlet application, which can run on both Windows and Linux systems
-* Metadata submitted to Metacat is broken into modules, which are stored to optimize rapid information retrieval
-* Metacat's Web interface facilitates the input and retrieval of data (Figure 1.1)
-* Metacat's optional mapping functionality enables you to query and visualize the geographic coverage of stored documents
+* Metacat is an open source web application, which can run on Linux, MacOS, and Windows operating systems and is written in Java
+* Metacat's Web interface facilitates the input and retrieval of data 
+* Metacat's optional mapping functionality enables you to query and visualize the geographic coverage of stored data sets
 * Metacat's replication feature ensures that all Metacat data and metadata is stored safely on multiple Metacat servers
-* The Metacat interface can be easily extended and customized via Web forms, skins, and/or user-developed Java clients
+* The Metacat interface can be easily extended and customized via Web forms, skins, and/or user-developed client tools in Java and other languages
 * The Metacat harvester automates the process of retrieving and storing EML documents from one or more sites
 * Metacat can be customized to use Life Sciences Identifiers (LSIDs), uniquely identifying every data record
 * Metacat has a built-in logging system for tracking events such as document insertions, updates, deletes, and reads
 * The appearance of Metacat's Web interface can be customized via skins. 
+* Metacat fully supports the DataONE Member Node interface, allowing Metacat deployments to easily participate in the DataONE federation
 
+.. figure:: images/screenshots/image007.jpg
+   :align: center
+
+   Metacat's default home page. Users can customize the appearance using skins.
+
+
+